var childProcess = require('child_process');

module.exports = function(filePath, callback){
    var cmd = process.platform === 'win32'
        ? __dirname + '/MediaInfo/' + (process.arch === 'x64' ? 'x64' : 'i386') + '/MediaInfo.exe'
        : 'mediainfo';

    childProcess.exec(cmd + ' ' + filePath, function(err, stdOut, stdErr){
        if (err || stdErr) {
            callback(err || stdErr);
        } else {
            var result = {}, _result, block;
            (stdOut || '').split('\n').forEach(function(line){
                line = line.trim();
                if (!line) {
                    return;
                }

                var i = line.indexOf(':');
                if (i === -1) {
                    if (line === 'General' && result[line]) {
                        if (!_result) {
                            _result = [ result ];
                        }
                        _result.push(result = {});
                    }

                    i = line.indexOf(' #');
                    if (i === -1) {
                        block = result[line] = {};
                    } else {
                        var key = line.substr(0, i);
                        if (!result[key]) {
                            result[key] = [];
                        }
                        result[key].push(block = {});
                    }
                } else {
                    block[line.substr(0, i).trim()] = line.substr(i + 1).trim();
                }
            });
            callback(null, _result || result, stdOut);
        }
    });
};

if (module.parent === null) {
    if (process.argv[2]) {
        module.exports(process.argv[2], function (err, result, stdOut) {
            console.log(err || result);
            stdOut && console.log(stdOut);
        });
    }
}